# Cormac Reynolds (reynolds@jive.nl): Jan 2006 original version
# a few simple, fragile (and deprecated) functions for accessing AIPS catalogs
# interactively. Not intended for use in real scripts.
from AIPS import AIPS, AIPSDisk
from AIPSTask import AIPSTask, AIPSList
from AIPSData import AIPSUVData, AIPSImage, AIPSCat
#from AIPSTV import AIPSTV
#import Wizardry.AIPSData
from evn_funcs import *

import LocalProxy
from xmlrpclib import ServerProxy

import copy, optparse, os, sys
import re, string, numarray, numarray.mlab, pprint, math

def getn(diskno, catno):
    # works just like the AIPS task and returns an AIPSUVData or AIPSImage
    # object.
    """ just like the AIPS task, but takes the disk as first argument"""

    catalog = get_catalog(diskno)

    for entry in catalog:
        entry_list = split_catalog_item(entry)
        if catno == int(entry_list[0]):
            aipsdata = getaipsdata(diskno, entry_list)
            print 'got ', aipsuvname(aipsdata)
            return aipsdata
    else:
        print 'Catalogue entry not found'


def alldest(aipsno):
    """ zaps all files in a given aips number (like the AIPS task) """

    AIPS.userno = aipsno

    for diskno in range( 1, len(AIPS.disks) ):
        print "disk ", str(diskno), ":"
        catalog = get_catalog(diskno)

        if catalog[0] == 'Empty':
            print "empty"
        else:
            for item in catalog:
                item_list = split_catalog_item(item)

                aipsdata = getaipsdata(diskno, item_list)
                zap_old_data(aipsdata)

def get_catalog(diskno, aipsno=None):
    """ Return the full catalog list for an aips number"""

    catalog_in = `AIPSCat(diskno)`
    catalog = catalog_in.splitlines()

    return catalog

def split_catalog_item(entry):
    """ split an aips catalog entry into its constituent parts """
    cat_re = re.compile(r'(\d+)\s(.{12})\.(.{6})\.(.{5})\s(.{2})')
    entry_match = cat_re.match(entry)
    entry_list = entry_match.groups()

    return entry_list


def getaipsdata(diskno, entry_list):
    """ shortcut way to get an aips data object, if you don't know (or care)
    whether it was a uvdata or imgdata object """

    if (entry_list[4] == 'UV'):
        aipsdata = AIPSUVData(entry_list[1], entry_list[2], diskno,
                int(entry_list[3]))
    elif(entry_list[4] == 'MA'):
        aipsdata = AIPSImage(entry_list[1], entry_list[2], diskno,
                int(entry_list[3]))

    return aipsdata

